## boomaga 3.0.0+git13

=== CMakeLists.txt ===
 # BEGIN_COMMON_COPYRIGHT_HEADER
 # (c)LGPL2+
 #
 #
 # Copyright: 2012-2018 Boomaga team https://github.com/Boomaga
 # Authors:
 #   Alexander Sokoloff <sokoloff.a@gmail.com>
 #
 # This program or library is free software; you can redistribute it
 # and/or modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2.1 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General
 # Public License along with this library; if not, write to the
 # Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 # Boston, MA 02110-1301 USA
 #
 # END_COMMON_COPYRIGHT_HEADER


cmake_minimum_required(VERSION 3.0.0)
cmake_policy(SET CMP0028 NEW)

project(boomaga)

set(MAJOR_VERSION 3)
set(MINOR_VERSION 0)
set(PATCH_VERSION 0)
#set(BETA_VERSION beta5)
set(FULL_VERSION ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
if (BETA_VERSION)
    set(FULL_VERSION ${FULL_VERSION}.${BETA_VERSION})
endif()


add_definitions(-DMAJOR_VERSION=${MAJOR_VERSION})
add_definitions(-DMINOR_VERSION=${MINOR_VERSION})
add_definitions(-DPATCH_VERSION=${PATCH_VERSION})
add_definitions(-DFULL_VERSION=\"${FULL_VERSION}\")

set (CMAKE_CXX_STANDARD 11)

include("cmake/tools.cmake")
include("cmake/status_message.cmake")
include("cmake/cxx_standard.cmake")

status_message("boomaga ver. ${FULL_VERSION}")
status_message(" ")


set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

find_program(CUPS_CONFIG_EXECUTABLE NAMES cups-config)
if(CUPS_CONFIG_EXECUTABLE)
    exec_program(${CUPS_CONFIG_EXECUTABLE} ARGS --serverbin OUTPUT_VARIABLE CUPS_SERVERBIN)
    set(DEF_CUPS_BACKEND_DIR "${CUPS_SERVERBIN}/backend")
else(CUPS_CONFIG_EXECUTABLE)
    message(FATAL_ERROR "Can't find cups-config. Are CUPS development packages installed?")
endif(CUPS_CONFIG_EXECUTABLE)

# Linux ***************************************
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

  set(DEF_CUPS_PPD_DIR /usr/share/ppd/boomaga)
  set(DEF_DBUS_SERVICE_DIR ${CMAKE_INSTALL_PREFIX}/share/dbus-1/services)
  set(USE_DBUS TRUE)
  set(GUI_DIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(NONGUI_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/boomaga)

# FreeBSD *************************************
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")

  set(DEF_CUPS_PPD_DIR /usr/local/share/cups/model)
  set(DEF_DBUS_SERVICE_DIR ${CMAKE_INSTALL_PREFIX}/share/dbus-1/services)
  set(USE_DBUS TRUE)
  set(GUI_DIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(NONGUI_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/boomaga)

# MacOS ***************************************
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")

  set(MAC_APP_ID    "io.github.Boomaga")
  set(MAC_SPOOL_DIR "/var/spool/${MAC_APP_ID}")

  set(DEF_CUPS_PPD_DIR ${CMAKE_INSTALL_PREFIX}/Library/Printers/PPDs/Contents/Resources)
  set(GUI_DIR    ${CMAKE_INSTALL_PREFIX}/Applications/Boomaga.app/Contents/MacOS)
  set(NONGUI_DIR ${CMAKE_INSTALL_PREFIX}/Applications/Boomaga.app/Contents/MacOS)
  set(USE_DBUS FALSE)

endif()

set(AUTOREMOVE_EXT "autoremove")
add_definitions(-DAUTOREMOVE_EXT=\"${AUTOREMOVE_EXT}\")

add_definitions(-DGUI_DIR=\"${GUI_DIR}\")
add_definitions(-DNONGUI_DIR=\"${NONGUI_DIR}\")

if (USE_DBUS)
  add_definitions(-DUSE_DBUS=1)
endif()


###########################################################

setFirstUpper(CUPS_BACKEND_NAME "boomaga")

setByDefault(CUPS_BACKEND_URI   "boomaga:/")
setByDefault(CUPS_BACKEND_INFO  "${CUPS_BACKEND_NAME}")
setByDefault(CUPS_BACKEND_MODEL "${CUPS_BACKEND_NAME} printer")
setByDefault(CUPS_BACKEND_DESCRIPTION  "Virtual boomaga printer")
setByDefault(CUPS_BACKEND_MANUFACTURER "Generic")

setByDefault(GUI_PROGRAM    ${GUI_DIR}/boomaga)
setByDefault(GUI_SHARE_DIR  ${CMAKE_INSTALL_PREFIX}/share/boomaga)

setByDefault(CUPS_BACKEND_DIR   "${DEF_CUPS_BACKEND_DIR}")
setByDefault(CUPS_PPD_DIR       "${DEF_CUPS_PPD_DIR}")
setByDefault(DBUS_SERVICE_DIR   "${DEF_DBUS_SERVICE_DIR}")


status_message(" ")
status_message("You can change the following directories using cmake options like:")
status_message("-DCUPS_PPD_DIR=your_path")
status_message(" ")
status_message("  CUPS_BACKEND_DIR     =  ${CUPS_BACKEND_DIR}")
status_message("  CUPS_PPD_DIR         =  ${CUPS_PPD_DIR}")
status_message("  DBUS_SERVICE_DIR     =  ${DBUS_SERVICE_DIR}")
status_message(" ")
status_message(" You can change the following options using cmake options:")
status_message("  CUPS_BACKEND_URI     =  ${CUPS_BACKEND_URI}")
status_message("  CUPS_BACKEND_INFO    =  ${CUPS_BACKEND_INFO}")
status_message("  CUPS_BACKEND_MODEL   =  ${CUPS_BACKEND_MODEL}")
status_message("  CUPS_BACKEND_DESCRIPTION  = ${CUPS_BACKEND_DESCRIPTION}")
status_message("  CUPS_BACKEND_MANUFACTURER = ${CUPS_BACKEND_MANUFACTURER}")
status_message(" ")

add_subdirectory(src/backend)
add_subdirectory(src/boomaga)
add_subdirectory(selinux)

show_status()

=== src/boomaga/CMakeLists.txt ===
 # BEGIN_COMMON_COPYRIGHT_HEADER
 # (c)LGPL2+
 #
 #
 # Copyright: 2012-2013 Boomaga team https://github.com/Boomaga
 # Authors:
 #   Alexander Sokoloff <sokoloff.a@gmail.com>
 #
 # This program or library is free software; you can redistribute it
 # and/or modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2.1 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General
 # Public License along with this library; if not, write to the
 # Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 # Boston, MA 02110-1301 USA
 #
 # END_COMMON_COPYRIGHT_HEADER


cmake_minimum_required(VERSION 3.0.0)
cmake_policy(SET CMP0028 NEW)
if (POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()


project(boomagaGui)

set(HEADERS
    boomagatypes.h
    dbus.h
    render.h
    settings.h
    finddbusaddress.h
    ../common.h

    kernel/sheet.h
    kernel/job.h
    kernel/tmppdffile.h
    kernel/layout.h
    kernel/project.h
    kernel/projectpage.h
    kernel/printer.h
    kernel/cupsprinteroptions.h
    kernel/pdfprocessor.h

    iofiles/infile.h
    iofiles/boofile.h
    iofiles/pdffile.h
    iofiles/cupsboofile.h
    iofiles/postscriptfile.h

    gui/mainwindow.h
    gui/actions.h
    gui/icon.h
    gui/aboutdialog/aboutdialog.h
    gui/configdialog/configdialog.h
    gui/export/exporttopdf.h
    gui/printdialog/printdialog.h
    gui/printersettings/printersettings.h
    gui/widgets/pagelistview.h
    gui/widgets/joblistview.h
    gui/widgets/layoutradiobutton.h
    gui/widgets/printerscombobox.h
    gui/widgets/previewwidget.h
    gui/widgets/subbookletview.h
    
    translations/translatorsinfo/translatorsinfo.h
    
    pdfparser/pdferrors.h
    pdfparser/pdfobject.h
    pdfparser/pdfreader.h
    pdfparser/pdfvalue.h
    pdfparser/pdfwriter.h
    pdfparser/pdfxref.h

)

set(SOURCES
    main.cpp
    boomagatypes.cpp
    dbus.cpp
    render.cpp
    settings.cpp
    finddbusaddress.cpp
    ../common.cpp

    kernel/sheet.cpp
    kernel/job.cpp
    kernel/tmppdffile.cpp
    kernel/layout.cpp
    kernel/project.cpp
    kernel/projectpage.cpp
    kernel/cupsprinteroptions.cpp
    kernel/printer.cpp
    kernel/pdfprocessor.cpp
    
    iofiles/infile.cpp
    iofiles/pdffile.cpp
    iofiles/boofile.cpp
    iofiles/cupsboofile.cpp
    iofiles/postscriptfile.cpp

    gui/mainwindow.cpp
    gui/actions.cpp
    gui/icon.cpp
    gui/aboutdialog/aboutdialog.cpp
    gui/configdialog/configdialog.cpp
    gui/export/exporttopdf.cpp
    gui/printdialog/printdialog.cpp
    gui/printersettings/printersettings.cpp
    gui/widgets/pagelistview.cpp
    gui/widgets/joblistview.cpp
    gui/widgets/layoutradiobutton.cpp
    gui/widgets/printerscombobox.cpp
    gui/widgets/previewwidget.cpp
    gui/widgets/subbookletview.cpp
    
    translations/translatorsinfo/translatorsinfo.cpp
    
    pdfparser/pdfobject.cpp
    pdfparser/pdfreader.cpp
    pdfparser/pdfvalue.cpp
    pdfparser/pdfwriter.cpp
    pdfparser/pdfxref.cpp
)


set(LIBRARIES
)

set(QT_USE_QTDBUS 1)

set(UI_FILES
    mainwindow.ui
    printersettings/printersettings.ui
    aboutdialog/aboutdialog.ui
    export/exporttopdf.ui
    configdialog/configdialog.ui
    printdialog/printdialog.ui
)

# QRC files .................
set(RESOURCES
    misc/images/icons.qrc
    misc/images/mainicon.qrc
)

# add translations ...
file (GLOB TS_FILES
    translations/boomaga*.ts
)

set(TRANSLATIONS_DIR
    "${GUI_SHARE_DIR}/translations"
)
add_definitions(-DTRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\")


#*******************************************
include("${CMAKE_SOURCE_DIR}/cmake/macos.cmake")
add_homebrew_qt_prefix_path()

include("${CMAKE_SOURCE_DIR}/cmake/git_version.cmake")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(Qt5 REQUIRED
    Core
    Widgets
    PrintSupport
    DBus
    LinguistTools
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)


SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
find_package(Cups REQUIRED QUIET)
include_directories(${CUPS_INCLUDE_DIR})
set(LIBRARIES ${LIBRARIES} ${CUPS_LIBRARIES})

find_package(Poppler REQUIRED QUIET)
include_directories(${POPPLERCPP_INCLUDE_DIRS})
set(LIBRARIES ${LIBRARIES} ${POPPLERCPP_LIBRARIES})

find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIRS})
set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})

if (APPLE)
 
    if (MAC_BUNDLE)
        add_definitions(-DMAC_BUNDLE=1)
        
        add_definitions(-DMAC_UPDATER=1)
        add_subdirectory(updater)
        set(LIBRARIES ${LIBRARIES} updater_mac)
    endif() 
endif()

include(translations/translatorsinfo/CMakeLists.txt)
get_translatorsinfo_qrc(translatorsinfo_qrc)
qt5_add_resources(TRANSLATORS_INFO_QRC ${translatorsinfo_qrc})

qt5_add_resources(  QRC_SOURCES ${RESOURCES})
qt5_add_translation(QM_FILES    ${TS_FILES})

add_executable(boomaga ${HEADERS} ${SOURCES} ${QM_FILES} ${QRC_SOURCES} ${TRANSLATORS_INFO_QRC})
target_link_libraries(boomaga ${LIBRARIES} Qt5::Widgets Qt5::PrintSupport Qt5::DBus)
set_target_properties(boomaga PROPERTIES OUTPUT_NAME "boomaga")




# MacOS ***************************************************
if( ${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")

    install(TARGETS boomaga RUNTIME DESTINATION "Applications/Boomaga.app/Contents/MacOS")
    set_target_properties(boomaga PROPERTIES OUTPUT_NAME "Boomaga")    

    install(FILES misc/images/mainicon/Boomaga.icns DESTINATION "Applications/Boomaga.app/Contents/Resources")

    install(FILES ${QM_FILES} DESTINATION "Applications/Boomaga.app/Contents/translations")

    CREATE_PLIST_FILE(misc/Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Info.plist DESTINATION "Applications/Boomaga.app/Contents")


# Linux + BSD ********************************************
else()
    install(TARGETS boomaga RUNTIME DESTINATION ${GUI_DIR})
    install(FILES ${QM_FILES} DESTINATION ${TRANSLATIONS_DIR})

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/org.boomaga.service
                   ${CMAKE_CURRENT_BINARY_DIR}/org.boomaga.service
                   @ONLY)

    include(cmake/CreateDesktopFile.cmake)
    CREATE_DESKTOP_FILE(misc/boomaga.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/boomaga.desktop translations/*.desktop)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.boomaga.service DESTINATION ${DBUS_SERVICE_DIR})


    install(FILES   misc/images/mainicon/boomaga-16x16.png   DESTINATION "share/icons/hicolor/16x16/apps"   RENAME "boomaga.png")
    install(FILES   misc/images/mainicon/boomaga-32x32.png   DESTINATION "share/icons/hicolor/32x32/apps"   RENAME "boomaga.png")
    install(FILES   misc/images/mainicon/boomaga-48x48.png   DESTINATION "share/icons/hicolor/48x48/apps"   RENAME "boomaga.png")
    install(FILES   misc/images/mainicon/boomaga-64x64.png   DESTINATION "share/icons/hicolor/64x64/apps"   RENAME "boomaga.png")
    install(FILES   misc/images/mainicon/boomaga-128x128.png DESTINATION "share/icons/hicolor/128x128/apps" RENAME "boomaga.png")
    install(FILES   misc/images/mainicon/boomaga-256x256.png DESTINATION "share/icons/hicolor/256x256/apps" RENAME "boomaga.png")
    install(FILES   misc/images/mainicon/boomaga-512x512.png DESTINATION "share/icons/hicolor/512x512/apps" RENAME "boomaga.png")

    install(FILES   ${CMAKE_CURRENT_BINARY_DIR}/boomaga.desktop DESTINATION "share/applications")
    install(FILES   misc/boomaga.xml        DESTINATION "share/mime/packages")
    install(FILES   misc/boomaga.1.gz       DESTINATION share/man/man1)
    # Linux + BSD *****************************************
endif()

add_tests("tests")

=== src/backend/cups_backend/CMakeLists.txt ===
 # BEGIN_COMMON_COPYRIGHT_HEADER
 # (c)LGPL2+
 #
 #
 # Copyright: 2012-2016 Boomaga team https://github.com/Boomaga
 # Authors:
 #   Alexander Sokoloff <sokoloff.a@gmail.com>
 #
 # This program or library is free software; you can redistribute it
 # and/or modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2.1 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General
 # Public License along with this library; if not, write to the
 # Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 # Boston, MA 02110-1301 USA
 #
 # END_COMMON_COPYRIGHT_HEADER

project(cups_backend)

set(HEADERS
    ../../common.h
)

set(SOURCES
    main.cpp
    ../../common.cpp
)



add_definitions(-DMAC_SPOOL_DIR=\"${MAC_SPOOL_DIR}\")

add_executable(${PROJECT_NAME} ${HEADERS} ${SOURCES})
target_link_libraries(${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "boomaga")

target_include_directories(${PROJECT_NAME} PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

# MacOS ***************************************************
if(APPLE)
    set(CUPS_BACKEND_DIR "usr/libexec/cups/backend")
    set(CUPS_PPD_DIR     "Library/Printers/PPDs/Contents/Resources")
endif()


install(FILES "${CMAKE_CURRENT_BINARY_DIR}/boomaga"
  DESTINATION ${CUPS_BACKEND_DIR}
  PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/boomaga.ppd
               ${CMAKE_CURRENT_BINARY_DIR}/boomaga.ppd
               @ONLY)


install(FILES ${CMAKE_CURRENT_BINARY_DIR}/boomaga.ppd
  DESTINATION ${CUPS_PPD_DIR}
  PERMISSIONS
    OWNER_READ OWNER_WRITE
    GROUP_READ
    WORLD_READ
)


if (APPLE)
        configure_file(apple.postinstall.in ${CMAKE_BINARY_DIR}/scripts/postinstall @ONLY)
endif()

=== src/backend/macos_agent/CMakeLists.txt ===
 # BEGIN_COMMON_COPYRIGHT_HEADER
 # (c)LGPL2+
 #
 #
 # Copyright: 2012-2018 Boomaga team https://github.com/Boomaga
 # Authors:
 #   Alexander Sokoloff <sokoloff.a@gmail.com>
 #
 # This program or library is free software; you can redistribute it
 # and/or modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2.1 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General
 # Public License along with this library; if not, write to the
 # Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 # Boston, MA 02110-1301 USA
 #
 # END_COMMON_COPYRIGHT_HEADER

cmake_minimum_required(VERSION 3.0.0)
cmake_policy(SET CMP0028 NEW)

project(agent)

set(MAC_APP_ID    "io.github.Boomaga")
add_definitions(-DMAC_APP_ID=\"${MAC_APP_ID}\")

set(HEADERS
    ../../common.h
)

set(SOURCES
  main.cpp
  ../../common.cpp
)

add_executable(${PROJECT_NAME} ${HEADERS} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "agent")

target_include_directories(${PROJECT_NAME} PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file(plist.in ${CMAKE_CURRENT_BINARY_DIR}/agent.plist @ONLY)

install(TARGETS ${PROJECT_NAME}   RUNTIME 
        DESTINATION "Library/Printers/${MAC_APP_ID}")

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/agent.plist         
	DESTINATION "Library/LaunchAgents"
	RENAME ${MAC_APP_ID}.agent.plist)

=== src/boomaga/tests/CMakeLists.txt ===
 # BEGIN_COMMON_COPYRIGHT_HEADER
 # (c)LGPL2+
 #
 #
 # Copyright: 2012-2014 Boomaga team https://github.com/Boomaga
 # Authors:
 #   Alexander Sokoloff <sokoloff.a@gmail.com>
 #
 # This program or library is free software; you can redistribute it
 # and/or modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2.1 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General
 # Public License along with this library; if not, write to the
 # Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 # Boston, MA 02110-1301 USA
 #
 # END_COMMON_COPYRIGHT_HEADER


cmake_minimum_required(VERSION 3.0.0)
cmake_policy(SET CMP0028 NEW)

project(boomaga_test)


set(TEST_HEADERS
    testboomaga.h
    tools.h

    ../pdfparser/pdferrors.h
    ../pdfparser/pdfreader.h
    ../pdfparser/pdfvalue.h
    ../pdfparser/pdfobject.h
    ../pdfparser/pdfwriter.h
    ../pdfparser/pdfxref.h
)

set(TEST_SOURCES
    testboomaga.cpp
    testpdfparser.cpp
    testpdfreader.cpp
    testpdfwriter.cpp
    test_infiles.cpp
    ../pdfparser/pdfreader.cpp
    ../pdfparser/pdfvalue.cpp
    ../pdfparser/pdfobject.cpp
    ../pdfparser/pdfwriter.cpp
    ../pdfparser/pdfxref.cpp
)


macro(ADD_FROM_PROJECT OUT_FILES)
    set (IN_FILES ${ARGN})
    foreach(FILE ${IN_FILES})
        if(NOT FILE STREQUAL "main.cpp")
            set(${OUT_FILES} ${${OUT_FILES}} "../${FILE}")
        endif()
    endforeach()
endmacro()


ADD_FROM_PROJECT(TEST_HEADERS ${HEADERS})
ADD_FROM_PROJECT(TEST_SOURCES ${SOURCES})


add_definitions(-DTEST_DATA_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/data/\")

set(TEST_OUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/output/")
file(MAKE_DIRECTORY ${TEST_OUT_DIR})
add_definitions(-DTEST_OUT_DIR=\"${TEST_OUT_DIR}\")

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

find_package(Qt5 REQUIRED
    Core
    Test
    Widgets
    PrintSupport
    DBus
    LinguistTools
)


add_executable(${PROJECT_NAME} ${TEST_HEADERS} ${TEST_SOURCES})
target_link_libraries(${PROJECT_NAME} ${LIBRARIES} Qt5::Core Qt5::Test Qt5::Widgets Qt5::PrintSupport Qt5::DBus)

=== src/boomaga/updater/CMakeLists.txt ===
 # BEGIN_COMMON_COPYRIGHT_HEADER
 # (c)LGPL2+
 #
 #
 # Copyright: 2019 Boomaga team https://github.com/Boomaga
 # Authors:
 #   Alexander Sokoloff <sokoloff.a@gmail.com>
 #
 # This program or library is free software; you can redistribute it
 # and/or modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2.1 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General
 # Public License along with this library; if not, write to the
 # Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 # Boston, MA 02110-1301 USA
 #
 # END_COMMON_COPYRIGHT_HEADER


project(updater_mac)

set(HEADERS 
    updater.h
)

set(SOURCES
    updater.mm
)

add_definitions(-DMAC_UPDATER=1)
add_library(${PROJECT_NAME} STATIC ${HEADERS} ${SOURCES})


set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})
find_package(Sparkle REQUIRED)
target_include_directories(${PROJECT_NAME} PRIVATE ${SPARKLE_INCLUDE_DIR})
target_link_libraries(${PROJECT_NAME} ${SPARKLE_LIBRARY})


FIND_LIBRARY(COCOA_LIBRARY Cocoa)
target_link_libraries(${PROJECT_NAME} ${COCOA_LIBRARY})


set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(Qt5 REQUIRED Core)
target_link_libraries(${PROJECT_NAME} Qt5::Core)

## boomaga 3.0.0+git13-g7f7ad47

=== debian/changelog ===
boomaga (3.0.0+git13-g7f7ad47-1build6) plucky; urgency=medium

  * Rebuild against latest poppler

 -- Alessandro Astone <alessandro.astone@canonical.com>  Fri, 17 Jan 2025 14:13:10 -0500

boomaga (3.0.0+git13-g7f7ad47-1build5) oracular; urgency=medium

  * Rebuild against latest poppler

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 21 Jun 2024 07:52:27 -0400

boomaga (3.0.0+git13-g7f7ad47-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:35:43 +1100

boomaga (3.0.0+git13-g7f7ad47-1build3) noble; urgency=medium

  * No-change rebuild against libpoppler-cpp0t64

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 21 Mar 2024 17:12:18 +1300

boomaga (3.0.0+git13-g7f7ad47-1build2) noble; urgency=medium

  * No-change rebuild against libcups2t64.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 20 Mar 2024 13:44:54 +1300

boomaga (3.0.0+git13-g7f7ad47-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:59:00 +0000

boomaga (3.0.0+git13-g7f7ad47-1) unstable; urgency=medium

  * Package upstream snapshot.
    - Fix incompatibility with GhostScript 9.54 (Closes: #998283).
    - Fix some typos.
  * Bump Standards-Version to 4.6.2, no changes required.
  * Bump debhelper compatibility to 13, using debian-compat in Build-Depends.
  * Set Rules-Requires-Root: no.
  * Bump watch version.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sun, 10 Sep 2023 12:50:03 -0300

=== debian/control ===
Source: boomaga
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dpkg-dev (>= 1.16.0~),
               libcups2-dev,
               libpoppler-cpp-dev,
               libpoppler-dev,
               libsnappy-dev,
               pkg-config,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/Boomaga/boomaga
Vcs-Git: https://gitlab.com/perezmeyer/debian-package-boomaga.git
Vcs-Browser: https://gitlab.com/perezmeyer/debian-package-boomaga

Package: boomaga
Architecture: any
Depends: cups, ${misc:Depends}, ${shlibs:Depends},
Description: virtual printer for viewing a document before printing
 Boomaga (BOOklet MAnager) is a virtual printer for viewing a document before
 printing it out using the physical printer.
 .
 The program is very simple to work with. Running any program, click "print"
 and select "Boomaga" to see in several seconds (CUPS takes some time to
 respond) the Boomaga window open.
 .
 If you print out one more document, it gets added to the previous one, and you
 can also print them out as one.
 .
 Regardless of whether your printer supports duplex printing or not, you would
 be able to easily print on both sides of the sheet.

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/boomaga-$1\.tar\.gz/ \
  https://github.com/Boomaga/boomaga/tags .*/v?(\d\S*)\.tar\.gz
